pragma Ada_95;
pragma Source_File_Name (ada_main, Spec_File_Name => "b~templates2ada.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b~templates2ada.adb");

with System.Restrictions;
with Ada.Exceptions;

package body ada_main is
   pragma Warnings (Off);

   E211 : Short_Integer; pragma Import (Ada, E211, "system__stack_usage_E");
   E018 : Short_Integer; pragma Import (Ada, E018, "system__soft_links_E");
   E012 : Short_Integer; pragma Import (Ada, E012, "system__exception_table_E");
   E058 : Short_Integer; pragma Import (Ada, E058, "ada__containers_E");
   E122 : Short_Integer; pragma Import (Ada, E122, "ada__io_exceptions_E");
   E009 : Short_Integer; pragma Import (Ada, E009, "ada__strings_E");
   E051 : Short_Integer; pragma Import (Ada, E051, "ada__strings__maps_E");
   E055 : Short_Integer; pragma Import (Ada, E055, "ada__strings__maps__constants_E");
   E096 : Short_Integer; pragma Import (Ada, E096, "ada__tags_E");
   E113 : Short_Integer; pragma Import (Ada, E113, "ada__streams_E");
   E065 : Short_Integer; pragma Import (Ada, E065, "interfaces__c_E");
   E127 : Short_Integer; pragma Import (Ada, E127, "interfaces__c__strings_E");
   E030 : Short_Integer; pragma Import (Ada, E030, "system__exceptions_E");
   E180 : Short_Integer; pragma Import (Ada, E180, "system__regpat_E");
   E207 : Short_Integer; pragma Import (Ada, E207, "system__task_info_E");
   E063 : Short_Integer; pragma Import (Ada, E063, "ada__calendar_E");
   E071 : Short_Integer; pragma Import (Ada, E071, "ada__calendar__time_zones_E");
   E169 : Short_Integer; pragma Import (Ada, E169, "gnat__calendar_E");
   E171 : Short_Integer; pragma Import (Ada, E171, "gnat__calendar__time_io_E");
   E153 : Short_Integer; pragma Import (Ada, E153, "gnat__directory_operations_E");
   E022 : Short_Integer; pragma Import (Ada, E022, "system__secondary_stack_E");
   E115 : Short_Integer; pragma Import (Ada, E115, "system__finalization_root_E");
   E112 : Short_Integer; pragma Import (Ada, E112, "ada__finalization_E");
   E117 : Short_Integer; pragma Import (Ada, E117, "system__storage_pools_E");
   E106 : Short_Integer; pragma Import (Ada, E106, "system__finalization_masters_E");
   E102 : Short_Integer; pragma Import (Ada, E102, "system__storage_pools__subpools_E");
   E094 : Short_Integer; pragma Import (Ada, E094, "ada__strings__unbounded_E");
   E061 : Short_Integer; pragma Import (Ada, E061, "ada__directories_E");
   E132 : Short_Integer; pragma Import (Ada, E132, "system__os_lib_E");
   E137 : Short_Integer; pragma Import (Ada, E137, "system__pool_global_E");
   E135 : Short_Integer; pragma Import (Ada, E135, "system__file_control_block_E");
   E144 : Short_Integer; pragma Import (Ada, E144, "ada__streams__stream_io_E");
   E125 : Short_Integer; pragma Import (Ada, E125, "system__file_io_E");
   E142 : Short_Integer; pragma Import (Ada, E142, "system__regexp_E");
   E151 : Short_Integer; pragma Import (Ada, E151, "gnat__command_line_E");
   E158 : Short_Integer; pragma Import (Ada, E158, "system__strings__stream_ops_E");
   E229 : Short_Integer; pragma Import (Ada, E229, "system__tasking__initialization_E");
   E237 : Short_Integer; pragma Import (Ada, E237, "system__tasking__protected_objects_E");
   E148 : Short_Integer; pragma Import (Ada, E148, "ada__text_io_E");
   E241 : Short_Integer; pragma Import (Ada, E241, "system__tasking__protected_objects__entries_E");
   E235 : Short_Integer; pragma Import (Ada, E235, "system__tasking__queuing_E");
   E191 : Short_Integer; pragma Import (Ada, E191, "templates_parser_tasking_E");
   E160 : Short_Integer; pragma Import (Ada, E160, "templates_parser_E");
   E185 : Short_Integer; pragma Import (Ada, E185, "templates_parser__input_E");
   E187 : Short_Integer; pragma Import (Ada, E187, "templates_parser__utils_E");

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
      LE_Set : Boolean;
      pragma Import (Ada, LE_Set, "__gnat_library_exception_set");
   begin
      declare
         procedure F1;
         pragma Import (Ada, F1, "templates_parser__finalize_body");
      begin
         E160 := E160 - 1;
         F1;
      end;
      declare
         procedure F2;
         pragma Import (Ada, F2, "templates_parser__finalize_spec");
      begin
         F2;
      end;
      declare
         procedure F3;
         pragma Import (Ada, F3, "templates_parser_tasking__finalize_body");
      begin
         E191 := E191 - 1;
         F3;
      end;
      E241 := E241 - 1;
      declare
         procedure F4;
         pragma Import (Ada, F4, "system__tasking__protected_objects__entries__finalize_spec");
      begin
         F4;
      end;
      E148 := E148 - 1;
      declare
         procedure F5;
         pragma Import (Ada, F5, "ada__text_io__finalize_spec");
      begin
         F5;
      end;
      E061 := E061 - 1;
      E142 := E142 - 1;
      declare
         procedure F6;
         pragma Import (Ada, F6, "system__regexp__finalize_spec");
      begin
         F6;
      end;
      E144 := E144 - 1;
      declare
         procedure F7;
         pragma Import (Ada, F7, "system__file_io__finalize_body");
      begin
         E125 := E125 - 1;
         F7;
      end;
      declare
         procedure F8;
         pragma Import (Ada, F8, "ada__streams__stream_io__finalize_spec");
      begin
         F8;
      end;
      declare
         procedure F9;
         pragma Import (Ada, F9, "system__file_control_block__finalize_spec");
      begin
         E135 := E135 - 1;
         F9;
      end;
      E137 := E137 - 1;
      declare
         procedure F10;
         pragma Import (Ada, F10, "system__pool_global__finalize_spec");
      begin
         F10;
      end;
      declare
         procedure F11;
         pragma Import (Ada, F11, "ada__directories__finalize_spec");
      begin
         F11;
      end;
      E094 := E094 - 1;
      declare
         procedure F12;
         pragma Import (Ada, F12, "ada__strings__unbounded__finalize_spec");
      begin
         F12;
      end;
      E102 := E102 - 1;
      declare
         procedure F13;
         pragma Import (Ada, F13, "system__storage_pools__subpools__finalize_spec");
      begin
         F13;
      end;
      E106 := E106 - 1;
      declare
         procedure F14;
         pragma Import (Ada, F14, "system__finalization_masters__finalize_spec");
      begin
         F14;
      end;
      E115 := E115 - 1;
      declare
         procedure F15;
         pragma Import (Ada, F15, "system__finalization_root__finalize_spec");
      begin
         F15;
      end;
      if LE_Set then
         declare
            LE : Ada.Exceptions.Exception_Occurrence;
            pragma Import (Ada, LE, "__gnat_library_exception");
            procedure Raise_From_Controlled_Operation (X : Ada.Exceptions.Exception_Occurrence);
            pragma Import (Ada, Raise_From_Controlled_Operation, "__gnat_raise_from_controlled_operation");
         begin
            Raise_From_Controlled_Operation (LE);
         end;
      end if;
   end finalize_library;

   procedure adafinal is
      procedure s_stalib_adafinal;
      pragma Import (C, s_stalib_adafinal, "system__standard_library__adafinal");
   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      s_stalib_adafinal;
   end adafinal;

   type No_Param_Proc is access procedure;

   procedure adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Exception_Tracebacks : Integer;
      pragma Import (C, Exception_Tracebacks, "__gl_exception_tracebacks");
      Zero_Cost_Exceptions : Integer;
      pragma Import (C, Zero_Cost_Exceptions, "__gl_zero_cost_exceptions");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");

      procedure Install_Handler;
      pragma Import (C, Install_Handler, "__gnat_install_handler");

      Handler_Installed : Integer;
      pragma Import (C, Handler_Installed, "__gnat_handler_installed");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      System.Restrictions.Run_Time_Restrictions :=
        (Set =>
          (False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, True, False, False, False, False, 
           False, False, False, False, False, False),
         Value => (0, 0, 0, 0, 0, 0, 0),
         Violated =>
          (True, False, True, True, False, False, False, True, 
           False, True, True, True, True, False, False, True, 
           False, False, True, True, False, True, True, True, 
           True, True, True, True, True, True, False, True, 
           False, False, True, False, True, True, False, False, 
           True, True, False, False, True, False, True, False, 
           False, False, False, False, False, True, True, True, 
           False, False, True, False, False, True, False, True, 
           True, False, True, True, True, False, True, True, 
           False, False, False, False, True, False),
         Count => (2, 0, 0, 0, 0, 1, 0),
         Unknown => (False, False, False, False, False, True, False));
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Exception_Tracebacks := 1;
      Zero_Cost_Exceptions := 1;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      if Handler_Installed = 0 then
         Install_Handler;
      end if;

      Finalize_Library_Objects := finalize_library'access;

      System.Stack_Usage'Elab_Spec;
      E211 := E211 + 1;
      System.Soft_Links'Elab_Spec;
      System.Exception_Table'Elab_Body;
      E012 := E012 + 1;
      Ada.Containers'Elab_Spec;
      E058 := E058 + 1;
      Ada.Io_Exceptions'Elab_Spec;
      E122 := E122 + 1;
      Ada.Strings'Elab_Spec;
      E009 := E009 + 1;
      Ada.Strings.Maps'Elab_Spec;
      Ada.Strings.Maps.Constants'Elab_Spec;
      E055 := E055 + 1;
      Ada.Tags'Elab_Spec;
      Ada.Streams'Elab_Spec;
      E113 := E113 + 1;
      Interfaces.C'Elab_Spec;
      Interfaces.C.Strings'Elab_Spec;
      System.Exceptions'Elab_Spec;
      E030 := E030 + 1;
      System.Regpat'Elab_Spec;
      System.Task_Info'Elab_Spec;
      E207 := E207 + 1;
      Ada.Calendar'Elab_Spec;
      Ada.Calendar'Elab_Body;
      E063 := E063 + 1;
      Ada.Calendar.Time_Zones'Elab_Spec;
      E071 := E071 + 1;
      Gnat.Calendar'Elab_Spec;
      E169 := E169 + 1;
      Gnat.Calendar.Time_Io'Elab_Spec;
      Gnat.Directory_Operations'Elab_Spec;
      E180 := E180 + 1;
      E127 := E127 + 1;
      E065 := E065 + 1;
      Ada.Tags'Elab_Body;
      E096 := E096 + 1;
      E051 := E051 + 1;
      System.Soft_Links'Elab_Body;
      E018 := E018 + 1;
      System.Secondary_Stack'Elab_Body;
      E022 := E022 + 1;
      System.Finalization_Root'Elab_Spec;
      E115 := E115 + 1;
      Ada.Finalization'Elab_Spec;
      E112 := E112 + 1;
      System.Storage_Pools'Elab_Spec;
      E117 := E117 + 1;
      System.Finalization_Masters'Elab_Spec;
      System.Finalization_Masters'Elab_Body;
      E106 := E106 + 1;
      System.Storage_Pools.Subpools'Elab_Spec;
      E102 := E102 + 1;
      Ada.Strings.Unbounded'Elab_Spec;
      E094 := E094 + 1;
      Ada.Directories'Elab_Spec;
      System.Os_Lib'Elab_Body;
      E132 := E132 + 1;
      Gnat.Directory_Operations'Elab_Body;
      E153 := E153 + 1;
      System.Pool_Global'Elab_Spec;
      E137 := E137 + 1;
      System.File_Control_Block'Elab_Spec;
      E135 := E135 + 1;
      Ada.Streams.Stream_Io'Elab_Spec;
      System.File_Io'Elab_Body;
      E125 := E125 + 1;
      E144 := E144 + 1;
      System.Regexp'Elab_Spec;
      E142 := E142 + 1;
      Ada.Directories'Elab_Body;
      E061 := E061 + 1;
      Gnat.Command_Line'Elab_Spec;
      System.Strings.Stream_Ops'Elab_Body;
      E158 := E158 + 1;
      System.Tasking.Initialization'Elab_Body;
      E229 := E229 + 1;
      System.Tasking.Protected_Objects'Elab_Body;
      E237 := E237 + 1;
      Ada.Text_Io'Elab_Spec;
      Ada.Text_Io'Elab_Body;
      E148 := E148 + 1;
      Gnat.Command_Line'Elab_Body;
      E151 := E151 + 1;
      E171 := E171 + 1;
      System.Tasking.Protected_Objects.Entries'Elab_Spec;
      E241 := E241 + 1;
      System.Tasking.Queuing'Elab_Body;
      E235 := E235 + 1;
      Templates_Parser_Tasking'Elab_Body;
      E191 := E191 + 1;
      Templates_Parser'Elab_Spec;
      Templates_Parser.Input'Elab_Spec;
      E185 := E185 + 1;
      Templates_Parser.Utils'Elab_Spec;
      E187 := E187 + 1;
      Templates_Parser'Elab_Body;
      E160 := E160 + 1;
   end adainit;

   procedure Ada_Main_Program;
   pragma Import (Ada, Ada_Main_Program, "_ada_templates2ada");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure Initialize (Addr : System.Address);
      pragma Import (C, Initialize, "__gnat_initialize");

      procedure Finalize;
      pragma Import (C, Finalize, "__gnat_finalize");
      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : aliased System.Address := Ada_Main_Program_Name'Address;
      pragma Volatile (Ensure_Reference);

   begin
      gnat_argc := argc;
      gnat_argv := argv;
      gnat_envp := envp;

      Initialize (SEH'Address);
      adainit;
      Ada_Main_Program;
      adafinal;
      Finalize;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   /builddir/build/BUILD/templates_parser-11.6.0/.build/native/release/relocatable/tobj/templates2ada.o
   --   -L/builddir/build/BUILD/templates_parser-11.6.0/.build/native/release/relocatable/tobj/
   --   -L/builddir/build/BUILD/templates_parser-11.6.0/.build/native/release/relocatable/lib/
   --   -L/usr/lib/xmlada/relocatable/
   --   -L/usr/lib/gcc/ppc64-redhat-linux/4.7.0/adalib/
   --   -shared
   --   -lgnarl-4.7
   --   -lgnat-4.7
   --   -lpthread
--  END Object file/option list   

end ada_main;
